#pragma once

#include <nlohmann/json.hpp>

namespace qthing {

using json = nlohmann::json;

class DeviceDescription {
 private:
  json j;

 public:
  DeviceDescription(const std::string& name) : j({{"name", name}}) {}

  void addLeds(int numLeds) {
    j["leds"] += numLeds;
  }

  const json& to_json() { return j; }
  std::string encode() { return j.dump(); }
};

}  // namespace qthing
